CallableStatementCallback (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.jdbc.core

## Interface CallableStatementCallback<T>

-     public interface CallableStatementCallback<T>

  Generic callback interface for code that operates on a CallableStatement. Allows to execute any number of operations on a single CallableStatement, for example a single execute call or repeated execute calls with varying parameters.

  Used internally by JdbcTemplate, but also useful for application code. Note that the passed-in CallableStatement can have been created by the framework or by a custom CallableStatementCreator. However, the latter is hardly ever necessary, as most custom callback actions will perform updates in which case a standard CallableStatement is fine. Custom actions will always set parameter values themselves, so that CallableStatementCreator capability is not needed either.

  Since:
    16.03.2004
  Author:
    Juergen Hoeller
  See Also:
    `JdbcTemplate.execute(String, CallableStatementCallback)`, `JdbcTemplate.execute(CallableStatementCreator, CallableStatementCallback)`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `T` | `doInCallableStatement(CallableStatement cs)` Gets called by `JdbcTemplate.execute` with an active JDBC CallableStatement.

- - ### Method Detail

    - #### doInCallableStatement

          T doInCallableStatement(CallableStatement cs)
                                  throws SQLException,
                                         DataAccessException

      Gets called by `JdbcTemplate.execute` with an active JDBC CallableStatement. Does not need to care about closing the Statement or the Connection, or about handling transactions: this will all be handled by Spring's JdbcTemplate.

      NOTE: Any ResultSets opened should be closed in finally blocks within the callback implementation. Spring will close the Statement object after the callback returned, but this does not necessarily imply that the ResultSet resources will be closed: the Statement objects might get pooled by the connection pool, with `close` calls only returning the object to the pool but not physically closing the resources.

      If called without a thread-bound JDBC transaction (initiated by DataSourceTransactionManager), the code will simply get executed on the JDBC connection with its transactional semantics. If JdbcTemplate is configured to use a JTA-aware DataSource, the JDBC connection and thus the callback code will be transactional if a JTA transaction is active.

      Allows for returning a result object created within the callback, i.e. a domain object or a collection of domain objects. A thrown RuntimeException is treated as application exception: it gets propagated to the caller of the template.

      Parameters:
        `cs` - active JDBC CallableStatement
      Returns:
        a result object, or `null` if none
      Throws:
        `SQLException` - if thrown by a JDBC method, to be auto-converted into a DataAccessException by a SQLExceptionTranslator
        `DataAccessException` - in case of custom exceptions